package serial;

import anywheresoftware.b4a.AbsObjectWrapper;

import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.IOnActivityResult;
import anywheresoftware.b4a.BA.Permissions;

import java.util.Arrays;
import java.util.Timer;
import java.util.TimerTask;
import java.util.Arrays;
import java.io.*;
import java.io.BufferedWriter;
//import anywheresoftware.b4a.BA.*;
import com.friendlyarm.FriendlyThings.HardwareControler;
import com.friendlyarm.FriendlyThings.SPIEnum;
import com.friendlyarm.FriendlyThings.GPIOEnum;
import com.friendlyarm.FriendlyThings.FileCtlEnum;
 
@ActivityObject
@Version(2.01f)
@ShortName("serial")
@Events(values={"enable_PWM(int mEnable)","change_PWM(int mCycle)","play_PWM(int mFreq, int mCycle, int mEnable)","stop_PWM()","GpIO_SetPin(Pin as int  , Valore as int  )" , "setGPIODirection(Pin as int,Direction as int)", "getGPIODirection(Pin As int)","_gpiopin(Stato As int)", "_write_success_ic2(successOpening As Boolean)", "port_open_ic2_success(successOpening As Boolean)","port_open_success_1(successOpening As Boolean)", "write_success_1(successWriting As Boolean)", "received_string_1(receivedString As byte)","port_open_success_2(successOpening As Boolean)", "write_success_2(successWriting As Boolean)", "received_string_2(receivedString As byte)",
"port_open_success_3(successOpening As Boolean)", "write_success_3(successWriting As Boolean)", "received_string_3(receivedString As byte)","I2C_WriteRead()", "GPIO_PinGet(String pin)", "GPIO_ValueGet(int pin)"})
@Author("Wrapper by: Vittorio Barile")
//@Permissions(values={"android.permission.INTERNET"})
//@DependsOn(values={"com.android.support:support-annotations", "com.android.support:support-v4", "com.android.support:appcompat-v7"})



public class serial extends AbsObjectWrapper<HardwareControler> {
    private HardwareControler hard_contr;
    private static final String TAG = "SerialPort";
    private final int MAXLINES = 200;
	//final int smart4418PWMGPIOPin = 97;
	//private int mBoardType = HardwareControler.getBoardType();	
    private StringBuilder remoteData = new StringBuilder(256 * MAXLINES);
    public long baudRate = 115200;
    public int dataBits = 8;
    public int stopBits = 1;
    private int devfd_1 = -1;   
	private int devfd_2 = -1;
	private int devfd_3 = -1;	
	private int devfd_4 = -1;	
	private int spi_fd = -1;  
	
    private String devName = "/dev/ttyAMA3";
    public String StringaInviata ;
	public String StringRicevuta;
	
	public int in  = 1;
	public int out = 2;
	public int low  = 0;
	public int high = 1;
	
    public int StatoGpio = -1;
	

    /**
     * Port /dev/ttyAMA1
     */   
    public String devName_ttyAMA1 = "/dev/ttyAMA1";
    /**
     * Port /dev/ttyAMA2
     */       
    public String devName_ttyAMA2 = "/dev/ttyAMA2";
    /**
     * Port /dev/ttyAMA3
     */       
    public String devName_ttyAMA3 = "/dev/ttyAMA3";
    /**
     * Port /dev/ttyAMA4
     */       
    public String devName_ttyAMA4 = "/dev/ttyAMA4";

    private final int BUFSIZE = 512;
    private byte[] buf_1 = new byte[BUFSIZE];   
	private byte[] buf_2 = new byte[BUFSIZE];   
	private byte[] buf_3 = new byte[BUFSIZE];   
    private Timer timer_1 = new Timer();
    private Timer timer_2 = new Timer();
	private Timer timer_3 = new Timer();
	  
    @Hide
    public static BA ba;
    @Hide
    public static String eventName;
        
    /**
     *Initialize the object
     *paramstring = starting name of the event(s) that will be raised
     */           
    public void Initialize(BA paramBA, String paramString) {
        eventName = paramString.toLowerCase(BA.cul);
        ba = paramBA;
        HardwareControler hard_contr = new HardwareControler();
        setObject(hard_contr);
    }   
    
    private boolean successOpening = false;
    /**
     * Open a serial port
     * devName = dev/ttyAMA1, /dev/ttyAMA2, /dev/ttyAMA3 or /dev/ttyAMA4 (default = /dev/ttyAMA3)
     * baudRate = Baud Rate (default = 115200)
     * dataBits = number of data bits (default = 8)
     * stopBits = number of stop bits (default = 1)
     */   
	 /**
	 accress ic2 : 0x1D
	 **/
	 
	 
	 
	
    public int openSerialport_1(String devName, long baudRate, int dataBits, int stopBits) {
        devfd_1 = hard_contr.openSerialPort(devName, baudRate, dataBits, stopBits);
        if (devfd_1 >= 0) {
            successOpening = true;
			timer_1.schedule(task_1, 0, 50); 
        } else {
            devfd_1 = -1;
            successOpening = false;
        }
        if (ba.subExists(eventName + "_port_open_success_1")) {
            ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_port_open_success_1", true, new Object[] {successOpening});
        }   
        return devfd_1;
    }
	
	
    
	public int openSerialport_2(String devName, long baudRate, int dataBits, int stopBits) {
        devfd_2 = hard_contr.openSerialPort(devName, baudRate, dataBits, stopBits);
        if (devfd_2 >= 0) {
            successOpening = true;
			timer_2.schedule(task_2, 0, 50); 
        } else {
            devfd_2 = -1;
            successOpening = false;
        }
        if (ba.subExists(eventName + "_port_open_success_2")) {
            ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_port_open_success_2", true, new Object[] {successOpening});
        }   
        return devfd_2;
    }
	
	public int openSerialport_3(String devName, long baudRate, int dataBits, int stopBits) {
        devfd_3 = hard_contr.openSerialPort(devName, baudRate, dataBits, stopBits);
        if (devfd_3 >= 0) {
            successOpening = true;
			timer_2.schedule(task_3, 0, 50); 
        } else {
            devfd_3 = -1;
            successOpening = false;
        }
        if (ba.subExists(eventName + "_port_open_success_3")) {
            ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_port_open_success_3", true, new Object[] {successOpening});
        }   
        return devfd_3;
    }
	

	
	
	public int openSerialportEX_2(String devName, long baudRate, int dataBits, int stopBits, String parityBit,String flowCtrl) {
        devfd_2 = hard_contr.openSerialPortEx(devName, baudRate, dataBits, stopBits,parityBit,flowCtrl);
        if (devfd_2 >= 0) {
            successOpening = true;
			timer_2.schedule(task_2, 0, 50); 
        } else {
            devfd_2 = -1;
            successOpening = false;
        }
        if (ba.subExists(eventName + "_port_open_success_2")) {
            ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_port_open_success_2", true, new Object[] {successOpening});
        }   
        return devfd_2;
    }
	
	public int openSerialportEX_3(String devName, long baudRate, int dataBits, int stopBits, String parityBit,String flowCtrl) {
        devfd_3 = hard_contr.openSerialPortEx(devName, baudRate, dataBits, stopBits,parityBit,flowCtrl);
        if (devfd_3 >= 0) {
            successOpening = true;
			timer_3.schedule(task_3, 0, 50); 
        } else {
            devfd_3 = -1;
            successOpening = false;
        }
        if (ba.subExists(eventName + "_port_open_success_3")) {
            ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_port_open_success_3", true, new Object[] {successOpening});
        }   
        return devfd_3;
    }
	
    /**
     * close the serial port
     */       
    public void closeSerialPort_1() {
        hard_contr.close(devfd_1);
        devfd_1 = -1;
		timer_1.cancel();
    }
        
	public void closeSerialPort_2() {
        hard_contr.close(devfd_2);
        devfd_2 = -1;
		timer_2.cancel();
    }
	public void closeSerialPort_3() {
        hard_contr.close(devfd_3);
        devfd_3 = -1;
		timer_3.cancel();
    }
        
    private boolean successWriting = false;
	//private byte[] SendByte; 
    //private String writestring = "";
    /**
     * Write a String to the port (i.e TX the string)
     */           
    public int writeStringToport_1 (byte SendByte[] ) {
        int ret = hard_contr.write(devfd_1, SendByte);
        if (ret > 0) {
            successWriting = true;
        } else {
            successWriting = false;
        }   
        if (ba.subExists(eventName + "_write_success_1")) {
            ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_write_success_1", true, new Object[] {successWriting});
        }   
        return ret;
    }
    
	    public int writeStringToport_2 (byte SendByte[] ) {
        int ret = hard_contr.write(devfd_2, SendByte);
        if (ret > 0) {
            successWriting = true;
        } else {
            successWriting = false;
        }   
        if (ba.subExists(eventName + "_write_success_2")) {
           ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_write_success_2", true, new Object[] {successWriting});
        }   
        return ret;
    }
	
	public int writeStringToport_3 (byte SendByte[] ) {
        int ret = hard_contr.write(devfd_3, SendByte);
        if (ret > 0) {
            successWriting = true;
        } else {
            successWriting = false;
        }   
        if (ba.subExists(eventName + "_write_success_3")) {
           ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_write_success_3", true, new Object[] {successWriting});
        }   
        return ret;
    }
	
	
    /**
     * Add readStringFromPort in a B4A timer - set the timer to tick every 500ms
     * Check if new data has been sent and then read the data
     */    

	public TimerTask task_1 = new TimerTask() {
		public void run() {
			readStringFromport_1();
		}
	};
	 
	public TimerTask task_2 = new TimerTask() {
		public void run() {
			readStringFromport_2();
		}
	};
	
	public TimerTask task_3 = new TimerTask() {
		public void run() {
			readStringFromport_3();
		}
	};
	public TimerTask task_4 = new TimerTask() {
		public void run() {
			I2C_WriteRead();
		}
	};
	
	
    public int readStringFromport_1() {
        int retSize = 0;
		byte[] buf_1 = new byte[BUFSIZE]; 
        if (hard_contr.select(devfd_1, 0, 0) == 1) {
            retSize = hard_contr.read(devfd_1, buf_1, BUFSIZE);
            if (retSize > 0) {
			    //StringRicevuta = new javax.xml.bind.DatatypeConverter.printHexBinary(bytes) ;
				byte[] buffinvio_1 =  Arrays.copyOfRange(buf_1, 0, retSize);  
			  
                if (ba.subExists(eventName + "_received_string_1")) {
                    ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_received_string_1", true, new Object[] {buffinvio_1});
                }
            }
        }
        return retSize;
            
    }

    public int readStringFromport_2() {
        int retSize = 0;
		byte[] buf_2 = new byte[BUFSIZE]; 
        if (hard_contr.select(devfd_2, 0, 0) == 1) {
            retSize = hard_contr.read(devfd_2, buf_2, BUFSIZE);
            if (retSize > 0) {
			    //StringRicevuta = new javax.xml.bind.DatatypeConverter.printHexBinary(bytes) ;
				byte[] buffinvio_2 =  Arrays.copyOfRange(buf_2, 0, retSize);  
			  
                if (ba.subExists(eventName + "_received_string_2")) {
                    ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_received_string_2", true, new Object[] {buffinvio_2});
                }
            }
        }
        return retSize;
            
    }

	public int readStringFromport_3() {
        int retSize = 0;
		byte[] buf_3 = new byte[BUFSIZE]; 
        if (hard_contr.select(devfd_3, 0, 0) == 1) {
            retSize = hard_contr.read(devfd_3, buf_3, BUFSIZE);
            if (retSize > 0) {
			    //StringRicevuta = new javax.xml.bind.DatatypeConverter.printHexBinary(bytes) ;
				byte[] buffinvio_3 =  Arrays.copyOfRange(buf_3, 0, retSize);  
			  
                if (ba.subExists(eventName + "_received_string_3")) {
                    ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_received_string_3", true, new Object[] {buffinvio_3});
                }
            }
        }
        return retSize;
            
    }

    
    public void GpIO_OnOff(int port , int valore ){
        int value ;
        value = hard_contr.getGPIOValue(port);
			if (ba.subExists(eventName + "_gpiopin")) {
				ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_gpiopin", true, new Object[] {value});
			}
           // Object r = ba.raiseEvent(this, eventName + "_devfdgpiopin", value);
			/**
            if (value == GPIOEnum.HIGH) {
                 value = GPIOEnum.LOW;
            } else {
                 value = GPIOEnum.HIGH;
            }
			**/
			if (valore == 0) {
                 value = GPIOEnum.LOW;
            } else {
                 value = GPIOEnum.HIGH;
            }
            devfd_1 = hard_contr.setGPIOValue(port,value);
			value = hard_contr.getGPIOValue(port);
			StatoGpio = value ;
            //r = ba.raiseEvent(this, eventName + "_risposta", value);
            //r = ba.raiseEvent(this, eventName + "_rispostagpio", devfd);
    } 
	
	 public int port_open_ic2_success(String devName) {
	    spi_fd = hard_contr.open(devName, FileCtlEnum.O_RDWR );
        if (spi_fd >= 0) {
            successOpening = true;
			timer_1.schedule(task_1, 0, 200); 
        } else {
            spi_fd = -1;
            successOpening = false;
        }
        if (ba.subExists(eventName + "_port_open_success")) {
            ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "port_open_ic2_success", true, new Object[] {successOpening});
        }   
        return spi_fd;
    }
	 
	public int writeStringToIc2(byte SendByte, int pos, int wait) {
		int ret = hard_contr.I2CWriteByte(spi_fd, SendByte, wait);  
        if (ret > 0) {
            successWriting = true;
        } else {
            successWriting = false;
        }   
        if (ba.subExists(eventName + "_write_success_ic2")) {
            ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_write_success_ic2", true, new Object[] {successWriting});
        }   
        return ret;
    }
	
	public int getGPIODirection( int pin ) {
		int ret = hard_contr.getGPIODirection(pin);  
        return ret;
    }
	
	public int setGPIODirection( int pin,int direction ) {
		int ret = hard_contr.setGPIODirection(pin,direction);  
        return ret;
    }
	
	public int port_open( String devName, int flags) {
	    spi_fd  = hard_contr.open(devName,flags );
        return spi_fd;
    }
	
	public int GpIO_SetPin(int pin  , int valore ){
        int value ;
		int ret ;
		value = hard_contr.exportGPIOPin(pin);
        ret = hard_contr.setGPIOValue(pin,valore);
		return ret;
    } 
	
	/*
	
	public int GPIO_PinSet(int pin  , int valore, ){
        int value ;
		int ret ;
		int flag = 2;
		
		spi_fd  = hard_contr.open("/sys/class/gpio/export",flag);
		String data = "63";
		byte[] byteData = data.getBytes();
		ret = hard_contr.write(spi_fd,byteData);
		hard_contr.close(spi_fd);
		
		spi_fd  = hard_contr.open("/sys/class/gpio/gpio63/direction",flag);
		data = "out";
		byteData = data.getBytes();
		ret = hard_contr.write(spi_fd,byteData);
		hard_contr.close(spi_fd);
		
		spi_fd  = hard_contr.open("/sys/class/gpio/gpio63/value",flag);
		data = "1";
		byteData = data.getBytes();
		ret = hard_contr.write(spi_fd,byteData);		
		hard_contr.close(spi_fd);
		
		return ret;
    } */


	public boolean GPIO_PinGet(String pin) {
	   int spi_fd1 = -1; 
	   char value;
	   int ret=0;
	   int flag = 2;
	   String direzione = "in";
	   
	   spi_fd1  = hard_contr.open("/sys/class/gpio/export",flag);
       String data = pin ;
       byte[] byteData1 = data.getBytes();
       ret = hard_contr.write(spi_fd1,byteData1);
       hard_contr.close(spi_fd1);
       
       spi_fd1  = hard_contr.open("/sys/class/gpio/gpio" +pin + "/direction",flag);
       //data = direzione ;
       byte[] byteData2 = data.getBytes();
       ret = hard_contr.write(spi_fd1,byteData2);
       hard_contr.close(spi_fd1);
	   
	   spi_fd1  = hard_contr.open("/sys/class/gpio/gpio" + pin +"/value", flag);
	   //String data = pin ;
       byte[] byteData3 = data.getBytes();
       ret = hard_contr.read(spi_fd1,byteData3,1);
	   hard_contr.close(spi_fd1);

	   if(ret == 0) {
		   return false;
		   
	   }
	    else{
			return true;
		}
		
	}


	public int GPIO_ValueGet(int pin) {
	   int value ;
       int ret ;
       int flag = 2;
       
       spi_fd  = hard_contr.open("/sys/class/gpio/gpio" + pin +"/value",flag);
	   String data = Integer.toString(pin);
	   byte[] byteData = data.getBytes();
       ret = hard_contr.getGPIOValue(pin);
	   hard_contr.close(spi_fd);
	   
	   return ret;
	}
	
	public void play_PWM(int mFreq, int mCycle, int mEnable) {
		final int freq = mFreq;
		final int cycle = mCycle;
		final int enable = mEnable;
		int spi_fd1 = -1;
		int ret;
		String data = "pwm0";
		
		new Thread() {
                @Override
                public void run() {
                    try {
                        File file = new File("/sys/class/pwm/pwm0/enable");
                        if (file.exists()) {
                            writeNumToFile("/sys/class/pwm/pwm0/enable", 0);
                            Thread.sleep(100);
                        } else {
                            writeNumToFile("/sys/class/pwm/pwmchip0/export", 0);
                            Thread.sleep(1000);
                        }
                            long period = 1000000000/(freq*1000);
                            writeNumToFile("/sys/class/pwm/pwm0/period", period);
                            Thread.sleep(100);
                            writeNumToFile("/sys/class/pwm/pwm0/duty_cycle", (long)(period * (cycle/100.0)));
                            Thread.sleep(100);
                            writeNumToFile("/sys/class/pwm/pwm0/enable", enable);
                            Thread.sleep(100);
							
                   } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }
            }.start();
    }
	
	public void change_PWM(int mCycle) {
		int ret;
		long cycle = (long)(500000 * (mCycle/100.0));
		spi_fd  = hard_contr.open("/sys/class/pwm/pwm0/duty_cycle", 2);
		String data =  Long.toString(cycle);
        byte[] byteData = data.getBytes();
		ret = hard_contr.write(spi_fd,byteData);
        hard_contr.close(spi_fd);
	}
	
	public void enable_PWM(int mEnable) {
		int ret;
		spi_fd  = hard_contr.open("/sys/class/pwm/pwm0/enable", 2);
		String data =  Integer.toString(mEnable);
        byte[] byteData = data.getBytes();
		ret = hard_contr.write(spi_fd,byteData);
        hard_contr.close(spi_fd);
	}
	
	void writeNumToFile(String fileName, long v) {
        //Log.d(TAG, "#### Write " + Long.toString(v) + " to " + fileName);
        try {
            BufferedWriter writer = new BufferedWriter(new FileWriter(fileName));
            writer.write(Long.toString(v));
            writer.close();
        } catch(IOException ie) {
            ie.printStackTrace();
            //Log.e(TAG, "Write file error: " + fileName);
            //Log.e(TAG, ie.toString());
            //sendMessage("Fail to write: " + fileName + "(value: " + Long.toString(v) + ")");
        } 
    }


	
	public int stop_PWM() {
		int dev1 = 0;
		dev1 = hard_contr.PWMStop();
        return dev1;
    }



	 public int GPIO_PinSetOnOff(String pin, String valore, String direzione){
       int value ;
       int ret ;
       int flag = 2;
       
       spi_fd  = hard_contr.open("/sys/class/gpio/export",flag);
       String data = pin ;
       byte[] byteData = data.getBytes();
       ret = hard_contr.write(spi_fd,byteData);
       hard_contr.close(spi_fd);
       
       spi_fd  = hard_contr.open("/sys/class/gpio/gpio" +pin + "/direction",flag);
       data = direzione ;
       byteData = data.getBytes();
       ret = hard_contr.write(spi_fd,byteData);
       hard_contr.close(spi_fd);
       
       spi_fd  = hard_contr.open("/sys/class/gpio/gpio" + pin +"/value",flag);
       data = valore ;
       byteData = data.getBytes();
       ret = hard_contr.write(spi_fd,byteData);        
       hard_contr.close(spi_fd);
       
       return ret;
   }
   //direzione IN
    public int GPIO_PinSetDirection(String pin, String direzione){
       int value ;
       int ret ;
       int flag = 2;
       
       spi_fd  = hard_contr.open("/sys/class/gpio/export",flag);
       String data = pin ;
       byte[] byteData = data.getBytes();
       ret = hard_contr.write(spi_fd,byteData);
       hard_contr.close(spi_fd);
       
       spi_fd  = hard_contr.open("/sys/class/gpio/gpio" +pin + "/direction",flag);
       data = direzione ;
       byteData = data.getBytes();
       ret = hard_contr.write(spi_fd,byteData);
       hard_contr.close(spi_fd);
       
       return ret;
   }
   
   
	
	
	public int[] I2C_WriteRead() {
        int retSize = 0;
		byte[] buf_3 = new byte[BUFSIZE];
		int i2c_fd = 0;
		int[] i2c_r = new int[6];
		int[] i2c_xyz = new int[3];
		byte RS1 = 0x31;
		byte[] buffer = new byte[6];
		byte[] data = new byte[2];		
		buffer[0] = 0x32;
		buffer[1] = 0x33;
		buffer[2] = 0x34;
		buffer[3] = 0x35;
		buffer[4] = 0x36;
		buffer[5] = 0x37;
		int x, y, z;
		int retA = 0;
		int devFDz = hard_contr.open("/dev/i2c-0", FileCtlEnum.O_RDWR);
		
		if(devFDz < 0) {
			return i2c_r;
		} else {
			
			if (hard_contr.setI2CSlave(devFDz, 0x31) < 0) {
				return i2c_r;
			} else {
				/*
			data[0]=0x2C;
			data[1]=0x0A;
			x = hard_contr.I2CWriteByteData(devFDz, 1, data[0],10);
			x = hard_contr.I2CWriteByteData(devFDz, 1, data[1],10);
			data[0]=0x2D;
			data[1]=0x08;
			y = hard_contr.I2CWriteByteData(devFDz, 1, data[0],10);
			y = hard_contr.I2CWriteByteData(devFDz, 1, data[1],10);
			data[0]=0x31;
			data[1]=0x08;
			z = hard_contr.I2CWriteByteData(devFDz, 1, data[0],10);
			z = hard_contr.I2CWriteByteData(devFDz, 1, data[1],10);
			*/
			for(int i = 0; i<6; i++) {
				i2c_fd = hard_contr.I2CWriteByteData(devFDz, 1, buffer[i], 10);
				 
				i2c_r[i] = hard_contr.I2CReadByteData(devFDz, 1, 10);
			}
			//i2c_fd = hard_contr.I2CWriteByteData(devFDz, 1, buffer[3], 500);
			// i2c_fd = hard_contr.I2CWriteByteTo(devFDz,  0x31, 0x0B, 0);
			// i2c_fd = hard_contr.I2CWriteByteTo(devFDz,  0x31, 0x2C, 0x09, 0);
			 
			i2c_xyz[0] =  ((i2c_r[1] & 0x03) * 256 + (i2c_r[0] & 0xFF));
			if(i2c_xyz[0] > 511)
			{
				i2c_xyz[0] -= 1024;
			}
			
			i2c_xyz[1] = ((i2c_r[3] & 0x03) * 256 + (i2c_r[2] & 0xFF));
			if(i2c_xyz[1] > 511)
			{
				i2c_xyz[1] -= 1024;
			}

			i2c_xyz[2] = ((i2c_r[5] & 0x03) * 256 + (i2c_r[4] & 0xFF));
			if(i2c_xyz[2] > 511)
			{
				i2c_xyz[2] -= 1024;
			}
				 
	  
			  hard_contr.close(devFDz);
			  return i2c_xyz;
			}
		}
	 
    }

	
	
	
}


   
   
   

